%%%%%%%%%%% CSC 320 A1 2005 Sample solutions

%%%%%%%%%%%%%%%%%%%%%%% Question 2 %%%%%%%%%%%%%%%%%%%%%%%%%%%%
N = 16;  % Must be even and > 4 (the support radius of the functions f(x))
dx = 0.02;
x0 = (-N/2):dx:(N/2);

%% Q2a
fprintf(1,'Question 2a\n');
x = x0;
g = zeros(size(x));
idx = x >= -4 & x <= 4;
g(idx) = 1 + cos(pi/4*x(idx));

k = -100:100;
omk = 2*pi/N * k;
ftg = zeros(size(k));

% The following will generate NaNs at divide by zeros,
% when omk == 0, pi/4, -pi/4.
ftg = 4/N * sin(omk * 4).*(2*ones(size(omk))./(4*omk) - ...
                           ones(size(omk))./ (4*omk - pi) - ...
                           ones(size(omk))./ (4*omk + pi));
% Patch up the NaN at k == 0
idx = (k == 0);
ftg(idx) = 8/N;

% omk = pi/4 implies 2pi * k/N = pi/4 so k = N/8
% Patch up the remaining NaN's when N is divisible by 8...
if (mod(N, 8) == 0)
  idx = (k == round(N/8));
  ftg(idx) = 4/N;
  idx = (k == -round(N/8));
  ftg(idx) = 4/N;
end

shift = N/2;
x = x0 + shift;
f = g;
ftf = ftg .* exp(-i*omk*shift); % Fourier shift

for K = [5 10 100] 

  recon = zeros(size(x));
  for j= find(k==-K):find(k==K)
    recon = recon + ftf(j) * exp(i*omk(j)*x);
  end

  figure(1); clf;
  plot(x,f, '-b');
  hold on;
  plot(x,real(recon), '-g');
  plot(x,imag(recon), '-r');
  title(sprintf('Fourier series with %d terms', K));
  
  imstats(abs(f -recon));
  pause;
  
end % over K


%% Q2b
fprintf(1,'Question 2b\n');
x = x0;
g = zeros(size(x));
idx = x >= -4 & x <= 0;
g(idx) = (x(idx)+4)/4;
idx = x <= 4 & x >= 0;
g(idx) = (4-x(idx))/4;

k = -100:100;
omk = 2*pi/N * k;
ftg = zeros(size(k));

% The following will generate a NaN at divide by zero (omk == 0)
ftg = 1/(2*N) * ones(size(omk)) ./ omk.^2;
ftg = ftg .* (1 - cos(omk * 4));

% Patch up the NaN.
idx = (k == 0);
ftg(idx) = 4/N;

shift = N/2;
x = x0 + shift;
f = g;
ftf = ftg .* exp(-i*omk*shift); % Fourier shift

for K = [5 10 100] 

  recon = zeros(size(x));
  for j= find(k==-K):find(k==K)
    recon = recon + ftf(j) * exp(i*omk(j)*x);
  end

  figure(1); clf;
  plot(x,f, '-b');
  hold on;
  plot(x,real(recon), '-g');
  plot(x,imag(recon), '-r');
  title(sprintf('Fourier series with %d terms', K));
  imstats(abs(f -recon));
  pause;
  
end % over K


%%%%%%%%%%%%%%%% Q2c
fprintf(1,'Question 2c\n');
x = x0;
g = zeros(size(x));
idx = x >= -4 & x <= 4;
g(idx) = 1;

k = -100:100;
omk = 2*pi/N * k;
ftg = zeros(size(k));
ftg = 8/N * sin(omk * 4)./(4*omk);  % will generate a NaN at divide by zero

% Patch up the NaN at k == 0
idx = (k == 0);
ftg(idx) = 8/N;

shift = N/2;
x = x0 + shift;
f = g; % f(x) = g(x-shift)
ftf = ftg .* exp(-i*omk*(shift)); % Fourier shift

for K = [5 10 100] 

  recon = zeros(size(x));
  for j= find(k==-K):find(k==K)
    recon = recon + ftf(j) * exp(i*omk(j)*x);
  end

  figure(1); clf;
  plot(x,f, '-b');
  hold on;
  plot(x,real(recon), '-g');
  plot(x,imag(recon), '-r');
  title(sprintf('Fourier series with %d terms', K));
  imstats(abs(f -recon));
  pause;
  
end % over K

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

