function f = catmullRomFunction(x)
  % return vector of function values at positions x for
  % the Catmull-Rom interpolation kernel.
  x = abs(x);  % Kernel is symmetric, so abs is ok.
  f = zeros(size(x));
  idx =  x < 1;  % Note x >= 0.
  if any(idx) % Evaluate poly for 0 <= x < 1
    f(idx) = 1 + 0.5 * (-5 * x(idx).^2 + 3 * x(idx).^3);
  end % Evaluate poly for 1 <= x < 2
  idx =  ~idx & x < 2;  
  if any(idx)
    y = x - 1;
    f(idx) = 0.5*(-y(idx) + 2* y(idx).^2  - y(idx).^3);
  end
  return;