%%%%%%%%%%%%%%%%% Test image translate

%% Bilinear test (linear image)
im = zeros([100 100]);
szIm = [100 100]
[x y] = meshgrid(1:szIm(2), 1:szIm(1));
a = [1 1];
im = a(1)*x+a(2)*y;
figure(1);clf; showIm(im);
pause;
xVec = [1.3 -3.7];

imT = translateIm(im, xVec, 'bilinear');

% imT(j,i) = im(j-xVec(2), i-xVec(1)) 
%  = a(2)*x(j-xVec(2),i-xVec(1)) + a(1)*y(j-xVec(2),i-xVec(1)) 
%  = a(2)*(j-xVec(2)) + a(1)* (i-xVec(1)))
% im(j,i) = a(2)*j + a(1)*i
% imT(j,i) - im(j,i) = -a(2)*xVec(2) - a(1)*xVec(1)

figure(1); clf;
showIm(double(isnan(imT)));
pause;

errIm = imT - im + a * xVec';
errIm(isnan(imT)) = 0;
figure(1); clf;
subplot(1,2,1);
showIm(errIm);
imstats(errIm);
subplot(1,2,2);
% away from boundaries
showIm(errIm(10:end-10,10:end-10));
% Error should be zero away from boundaries
imstats(errIm(10:end-10,10:end-10));
pause;

%% Bilinear test (quadratic image)
im = zeros([100 100]);
szIm = [100 100]
[x y] = meshgrid(1:szIm(2), 1:szIm(1));
a = [1 1 0.01 -0.02 0.01];
im = a(1)*x+a(2)*y + a(3) * x.*x +  a(4) * x.*y  +  a(5) * y.*y ;
figure(1);clf; showIm(im);
pause;
xVec = [1.3 -3.7];

imT = translateIm(im, xVec, 'bilinear');

% imT(j,i) = im(j-xVec(2), i-xVec(1)) 
figure(1); clf;
showIm(double(isnan(imT)));
pause;

xs = x - xVec(1); ys = y - xVec(2);
im0 = a(1)*xs+a(2)*ys + a(3) * xs.*xs +  a(4) * xs.*ys  +  a(5) * ys.*ys ;

errIm = imT - im0;
errIm(isnan(imT)) = 0;
figure(1); clf;
subplot(1,2,1);
showIm(errIm);
imstats(errIm);
subplot(1,2,2);
% away from boundaries
showIm(errIm(10:end-10,10:end-10));

% Error should be small but non-zero (0.0042) away from boundaries
imstats(errIm(10:end-10,10:end-10));
pause;

%%%%%%%%%%%%%% Bicubic test (linear image)
im = zeros([100 100]);
szIm = [100 100]
[x y] = meshgrid(1:szIm(2), 1:szIm(1));
a = [1 1];
im = a(1)*x+a(2)*y;
figure(1);clf; showIm(im);
pause;
xVec = [1.3 -3.7];

imT = translateIm(im, xVec, 'bicubic');

% imT(j,i) = im(j-xVec(2), i-xVec(1)) 
%  = a(2)*x(j-xVec(2),i-xVec(1)) + a(1)*y(j-xVec(2),i-xVec(1)) 
%  = a(2)*(j-xVec(2)) + a(1)* (i-xVec(1)))
% im(j,i) = a(2)*j + a(1)*i
% imT(j,i) - im(j,i) = -a(2)*xVec(2) - a(1)*xVec(1)

figure(1); clf;
showIm(double(isnan(imT)));
pause;

errIm = imT - im + a * xVec';
errIm(isnan(imT)) = 0;
figure(1); clf;
subplot(1,2,1);
showIm(errIm);
imstats(errIm);
subplot(1,2,2);
% away from boundaries
showIm(errIm(10:end-10,10:end-10));
% Error should be zero away from boundaries
imstats(errIm(10:end-10,10:end-10));
pause;

%% Bicubic test (quadratic image)
im = zeros([100 100]);
szIm = [100 100]
[x y] = meshgrid(1:szIm(2), 1:szIm(1));
a = [1 1 0.01 -0.02 0.01];
im = a(1)*x+a(2)*y + a(3) * x.*x +  a(4) * x.*y  +  a(5) * y.*y ;
figure(1);clf; showIm(im);
pause;
xVec = [1.3 -3.7];

imT = translateIm(im, xVec, 'bicubic');

% imT(j,i) = im(j-xVec(2), i-xVec(1)) 
figure(1); clf;
showIm(double(isnan(imT)));
pause;

xs = x - xVec(1); ys = y - xVec(2);
im0 = a(1)*xs+a(2)*ys + a(3) * xs.*xs +  a(4) * xs.*ys  +  a(5) * ys.*ys ;

errIm = imT - im0;
errIm(isnan(imT)) = 0;
figure(1); clf;
subplot(1,2,1);
showIm(errIm);
imstats(errIm);
subplot(1,2,2);
% away from boundaries
showIm(errIm(10:end-10,10:end-10));

% Error should be zero away from boundaries
imstats(errIm(10:end-10,10:end-10));
pause;


